// DrivePlatformDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DrivePlatform.h"
#include "DrivePlatformDlg.h"
#include ".\driveplatformdlg.h"

#include <string>
#include <ace/os.h>
#include "ace/ace.h"

#include "acetenathread.h"
#include "OSGDefines.h"

#define TENA_PLATFORM xp-vc71-d

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define STEERINGWHEEL  1
#define RUMBLEPAD      2

extern double radToDeg;


// These are the vars filled by TENA output and used to drive the 3D display
extern double _positionX;
extern double _positionY ;
extern double _positionZ ;
extern double _heading ;
extern double _theta ;
extern double _phi ;

extern double 	_elevation ;
extern double 	_velocity ;
extern double 	_xJitterOffset ;
extern double 	_yJitterOffset ;
extern double 	_zJitterOffset ;

extern int _UID;


int globalSteeringDevice = RUMBLEPAD;
extern short globalTopViewType;
extern short globalBottomViewType;

// Global for trigerring FFeedback
float globalForceMagnitude;// = 10000.0f ;
float globalForcePeriod = 0.15;
float globalX = 0.0f;
float globalY = 0.0f;
bool bUseFF = false;
bool bDisableFFMagnitude = false;

float globalHeading;
float globalTheta;
float globalPhi;

void LaunchOSG(void);


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDrivePlatformDlg dialog



CDrivePlatformDlg::CDrivePlatformDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDrivePlatformDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDrivePlatformDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CDrivePlatformDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO_STEERINGWHEEL, OnBnClickedRadioSteeringwheel)
	ON_BN_CLICKED(IDC_RADIO_RUMBLEPAD, OnBnClickedRadioRumblepad)
	ON_BN_CLICKED(IDC_BUTTON_JOINTENA, OnBnClickedButtonJointena)
	ON_BN_CLICKED(IDC_BUTTON_SHOWVIEWER, OnBnClickedButtonShowviewer)
	ON_BN_CLICKED(IDC_RADIO_GODSEYE, OnBnClickedRadioGodseye)
	ON_BN_CLICKED(IDC_RADIO_FOLLOW, OnBnClickedRadioFollow)
	ON_BN_CLICKED(IDC_RADIO_COCKPIT, OnBnClickedRadioCockpit)
END_MESSAGE_MAP()


// CDrivePlatformDlg message handlers

BOOL CDrivePlatformDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	SendDlgItemMessage(IDC_RADIO_RUMBLEPAD,BM_SETCHECK,1,1);
	SendDlgItemMessage(IDC_RADIO_STEERINGWHEEL,BM_SETCHECK,0,0);
	globalSteeringDevice = RUMBLEPAD;

	SendDlgItemMessage(IDC_RADIO_COCKPIT,BM_SETCHECK,1,1);

	// this is the timer so that events can get recognized in the MFC gui world
	_nTimer = SetTimer(1, 100, NULL);

	InitCommonControls();

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDrivePlatformDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDrivePlatformDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDrivePlatformDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CDrivePlatformDlg::OnBnClickedRadioSteeringwheel()
{
	globalSteeringDevice = STEERINGWHEEL;
	SendDlgItemMessage(IDC_RADIO_RUMBLEPAD,BM_SETCHECK,0,0);
}

void CDrivePlatformDlg::OnBnClickedRadioRumblepad()
{
	globalSteeringDevice = RUMBLEPAD;
	SendDlgItemMessage(IDC_RADIO_STEERINGWHEEL,BM_SETCHECK,0,0);
}

void CDrivePlatformDlg::OnBnClickedButtonJointena()
{
	thread_data myArgs;
    //ACE::init();
	ACE_Thread_Manager *tm = ACE_Thread_Manager::instance();
	
	tm->spawn(ACE_THR_FUNC(StartTENAThread), (void *) &myArgs);
	
	ACE_OS::sleep(ACE_Time_Value(5,0));
}

void CDrivePlatformDlg::OnBnClickedButtonShowviewer()
{
	LaunchOSG();
}

void CDrivePlatformDlg::OnBnClickedRadioGodseye()
{
	SendDlgItemMessage(IDC_RADIO_COCKPIT,BM_SETCHECK,0,0);
	SendDlgItemMessage(IDC_RADIO_FOLLOW,BM_SETCHECK,0,0);
	SendDlgItemMessage(IDC_RADIO_GODSEYE,BM_SETCHECK,1,1);
	globalTopViewType = GODSEYE;
}

void CDrivePlatformDlg::OnBnClickedRadioFollow()
{
	SendDlgItemMessage(IDC_RADIO_COCKPIT,BM_SETCHECK,0,0);
	SendDlgItemMessage(IDC_RADIO_FOLLOW,BM_SETCHECK,1,1);
	SendDlgItemMessage(IDC_RADIO_GODSEYE,BM_SETCHECK,0,0);
	globalTopViewType = FOLLOW;
}

void CDrivePlatformDlg::OnBnClickedRadioCockpit()
{
	SendDlgItemMessage(IDC_RADIO_COCKPIT,BM_SETCHECK,1,1);
	SendDlgItemMessage(IDC_RADIO_FOLLOW,BM_SETCHECK,0,0);
	SendDlgItemMessage(IDC_RADIO_GODSEYE,BM_SETCHECK,0,0);
	globalTopViewType = COCKPIT;
}

void LaunchOSG(void)
{
	thread_data myArgs;
    ACE::init();
	ACE_Thread_Manager *tm = ACE_Thread_Manager::instance();
	
	tm->spawn(ACE_THR_FUNC(StartOSGThread), (void *) &myArgs);
	
	ACE_OS::sleep(ACE_Time_Value(5,0));

}

void CDrivePlatformDlg::OnTimer(UINT nIDEvent)
{

	CString str = _T("");

	str.Format("%f",_positionX);
	GetDlgItem(IDC_STATIC_XPOS)->SetWindowText(str);

	str.Format("%f",_positionY);
	GetDlgItem(IDC_STATIC_YPOS)->SetWindowText(str);

	str.Format("%f",_positionZ);
	GetDlgItem(IDC_STATIC_ZPOS)->SetWindowText(str);

	str.Format("%f",_heading*radToDeg);
	str.Format("%f",globalHeading*radToDeg);
	GetDlgItem(IDC_STATIC_PSI)->SetWindowText(str);

	str.Format("%f",_theta*radToDeg);
	str.Format("%f",globalTheta*radToDeg);
	GetDlgItem(IDC_STATIC_THETA)->SetWindowText(str);

	str.Format("%f",_phi*radToDeg);
	str.Format("%f",globalPhi*radToDeg);
	GetDlgItem(IDC_STATIC_PHI)->SetWindowText(str);

	str.Format("%d",_UID);
	GetDlgItem(IDC_STATIC_ID)->SetWindowText(str);

	UpdateData(FALSE);

	CDialog::OnTimer(nIDEvent);
}
