/////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file RTTC/EnvironmentalEffects/TerrainTypeChangeMessage/BasicImpl/MessageCallbackFactoryImpl.cpp
 * \version 5.2.1
 *
 * \brief Contains the definition of methods of
 * RTTC::EnvironmentalEffects::TerrainTypeChangeMessage::BasicImpl::MessageCallbackFactoryImpl.
 *
 * This file contains the definition of the methods of the
 * RTTC::EnvironmentalEffects::TerrainTypeChangeMessage::BasicImpl::MessageCallbackFactoryImpl class.
 */

#include "MessageCallbackFactoryImpl.h"
#include <RTTC/EnvironmentalEffects/TerrainTypeChangeMessage/Interface.h>

///////////////////////////////////////////////////////////////////////////////
RTTC::EnvironmentalEffects::TerrainTypeChangeMessage::BasicImpl::
MessageCallbackFactoryImpl::
~MessageCallbackFactoryImpl()
{
  // Basic implementation has no behavior required in callback destructor
}

///////////////////////////////////////////////////////////////////////////////
RTTC::EnvironmentalEffects::TerrainTypeChangeMessage::BasicImpl::
MessageCallbackFactoryImpl::
MessageCallbackFactoryImpl( CallbackInfoPtr const & pCallbackInfo )
  :
  _pCallbackInfo( pCallbackInfo )
{
  // Generally no behavior in a factory constructor
}

///////////////////////////////////////////////////////////////////////////////
std::auto_ptr< TENA::Middleware::Callback::Callback >
RTTC::EnvironmentalEffects::TerrainTypeChangeMessage::BasicImpl::
MessageCallbackFactoryImpl::
create( RTTC::EnvironmentalEffects::TerrainTypeChangeMessage::Pointer const & pMessage )
{
  // For the basic implementation, all the callbacks access a list
  // of Messages, which is kept updated as Messages are received

  return std::auto_ptr< TENA::Middleware::Callback::Callback >(
    new MessageCallbackImpl(
      pMessage,
      _pCallbackInfo ) );
}
