/////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file TENA/Platform/BasicImpl/SubscriptionInfoImpl.cpp
 * \version 5.2.1
 *
 * \brief Contains the definition of methods of
 * TENA::Platform::BasicImpl::SubscriptionInfoImpl.
 *
 * This file contains the definition of the methods of the
 * TENA::Platform::BasicImpl::SubscriptionInfoImpl class.
 */

#include "SubscriptionInfoImpl.h"
#include "CallbackInfo.h" // To give smart pointer complete type for deletion

#include "DestructionCallbackFactoryImpl.h"
#include <TENA/Platform/NullDestructionCallbackFactory.h>
#include "DiscoveryCallbackFactoryImpl.h"
#include <TENA/Platform/NullDiscoveryCallbackFactory.h>
#include "StateChangeCallbackFactoryImpl.h"
#include <TENA/Platform/NullStateChangeCallbackFactory.h>


///////////////////////////////////////////////////////////////////////////////
TENA::Platform::BasicImpl::
SubscriptionInfoImpl::
SubscriptionInfoImpl( CallbackInfoPtr const & pCallbackInfo )
:
  TENA::Platform::SubscriptionInfo(
    DiscoveryCallbackFactoryPtr(
      new DiscoveryCallbackFactoryImpl( pCallbackInfo ) ),
    StateChangeCallbackFactoryPtr(
      new StateChangeCallbackFactoryImpl( pCallbackInfo ) ),
    DestructionCallbackFactoryPtr(
      new DestructionCallbackFactoryImpl( pCallbackInfo ) )   )
{
}

///////////////////////////////////////////////////////////////////////////////
TENA::Platform::BasicImpl::
SubscriptionInfoImpl::
~SubscriptionInfoImpl()
{
}
