//////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file TENA/Platform/DisturbanceServer/DiscoveryCallbackFactoryImpl.cpp
 * \version 5.2.1
 *
 * \brief Contains the definition of methods of
 * TENA::Platform::DisturbanceServer::DiscoveryCallbackFactoryImpl.
 *
 * This file contains the definition of the methods of the
 * TENA::Platform::DisturbanceServer::DiscoveryCallbackFactoryImpl class.
 */

#include "DiscoveryCallbackFactoryImpl.h"

////////////////////////////////////////////////////////////////////////////////
TENA::Platform::DisturbanceServer::
DiscoveryCallbackFactoryImpl::
~DiscoveryCallbackFactoryImpl()
{
  // Basic implementation has no behavior required in callback destructor
}

////////////////////////////////////////////////////////////////////////////////
TENA::Platform::DisturbanceServer::
DiscoveryCallbackFactoryImpl::
DiscoveryCallbackFactoryImpl( CallbackInfoPtr const & pCallbackInfo )
  :
  _pCallbackInfo( pCallbackInfo )
{
  // Generally no behavior in a factory constructor
}

////////////////////////////////////////////////////////////////////////////////
std::auto_ptr< TENA::Middleware::Callback::Callback >
TENA::Platform::DisturbanceServer::
DiscoveryCallbackFactoryImpl::
create( TENA::Platform::ProxyPtr const & pProxy )
{
  // For the basic implementation, all the callbacks access a list
  // of SDOs, which is kept updated as SDO's are discovered and destroyed

  return std::auto_ptr< TENA::Middleware::Callback::Callback >(
    new TENA::Platform::DisturbanceServer::DiscoveryCallbackImpl(
      pProxy,
      _pCallbackInfo ) );
}
