//////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file TENA/Platform/DisturbanceServer/LocalPublicationInfoImpl.inl
 * \version 5.2.1
 *
 * Contains the definition of locally defined PublicationInfoImpl classes
 * defined to break unneeded dependencies for generated code.
 *
 * The dependency on the PublicationInfoImpl for inherited classes should not
 *  exist, but is part of the current implementation of PublicationInfo
 *
 * These includes are used to generate PublicationInfo's impls that can be ignored.
 * Declare and define classes in a single file for simplicity
 */

#include "PublicationInfoImpl.h"

#include <TENA/Platform/RemoteMethodsFactoryInterface.h>


// Use an anonymous namespace so these defined classes are only accessible locally
// and do not conflict with other PublicationInfoImpl that might be named identically
// since identical classes may get generated for multiple SDOs

// Define the local implementations (for superclass publicationinfos)
namespace
{
}
