/////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file TENA/Platform/DisturbanceServer/PublisherImpl.h
 * \version 5.2.1
 *
 * \brief \#include this file in order to instantiate
 * TENA::Platform SDO Servant objects.
 *
 * This file is the one header file that an application
 * programs should \#include in order to instantiate
 * TENA::Platform SDO Servant objects using the
 * implementation defined in TENA/Platform/DisturbanceServer.
 *
 * This header file aggregates the header files
 * needed by most TENA Middleware application to be able to create
 * TENA::Platform SDO Servant objects.
 *
 */

#ifndef TENA_Platform_DisturbanceServer_PublisherImpl_h
#define TENA_Platform_DisturbanceServer_PublisherImpl_h

#include <TENA/Platform/Publisher.h>
#include "PublicationInfoImpl.h"


// This code is to force linkage of a Windows dll with local methods implementations
// For each explicit implementation dependency, define an external symbol which
// is resolved by the external implementation library.  

#if defined(_MSC_VER)
#define IMPORT_LINKED_DLL __declspec(dllimport)
#else
#define IMPORT_LINKED_DLL
#endif
extern IMPORT_LINKED_DLL int userDefined_v1_TENA_UniqueID_v2_forceThisLibraryToBeLinked;
extern IMPORT_LINKED_DLL int fullConversion_v3_TENA_Time_v1_1_forceThisLibraryToBeLinked;
extern IMPORT_LINKED_DLL int csvReader_v2_TENA_PlatformType_v1_forceThisLibraryToBeLinked;
extern IMPORT_LINKED_DLL int positionConversion_v4_TENA_TSPI_v4_forceThisLibraryToBeLinked;
extern IMPORT_LINKED_DLL int noConversion_v3_TENA_Orientation_v1_forceThisLibraryToBeLinked;
extern IMPORT_LINKED_DLL int utils_v3_TENA_SRF_v1_forceThisLibraryToBeLinked;
extern IMPORT_LINKED_DLL int noConversion_v3_TENA_Velocity_v1_forceThisLibraryToBeLinked;
extern IMPORT_LINKED_DLL int fullConversion_v3_TENA_Position_v1_forceThisLibraryToBeLinked;
extern IMPORT_LINKED_DLL int noConversion_v3_TENA_Acceleration_v1_forceThisLibraryToBeLinked;

namespace
{
  // These symbol names must match the names that exist in existing implementations
  int useuserDefined_v1_TENA_UniqueID_v2_forceThisLibraryToBeLinked = userDefined_v1_TENA_UniqueID_v2_forceThisLibraryToBeLinked;
  int usefullConversion_v3_TENA_Time_v1_1_forceThisLibraryToBeLinked = fullConversion_v3_TENA_Time_v1_1_forceThisLibraryToBeLinked;
  int usecsvReader_v2_TENA_PlatformType_v1_forceThisLibraryToBeLinked = csvReader_v2_TENA_PlatformType_v1_forceThisLibraryToBeLinked;
  int usepositionConversion_v4_TENA_TSPI_v4_forceThisLibraryToBeLinked = positionConversion_v4_TENA_TSPI_v4_forceThisLibraryToBeLinked;
  int usenoConversion_v3_TENA_Orientation_v1_forceThisLibraryToBeLinked = noConversion_v3_TENA_Orientation_v1_forceThisLibraryToBeLinked;
  int useutils_v3_TENA_SRF_v1_forceThisLibraryToBeLinked = utils_v3_TENA_SRF_v1_forceThisLibraryToBeLinked;
  int usenoConversion_v3_TENA_Velocity_v1_forceThisLibraryToBeLinked = noConversion_v3_TENA_Velocity_v1_forceThisLibraryToBeLinked;
  int usefullConversion_v3_TENA_Position_v1_forceThisLibraryToBeLinked = fullConversion_v3_TENA_Position_v1_forceThisLibraryToBeLinked;
  int usenoConversion_v3_TENA_Acceleration_v1_forceThisLibraryToBeLinked = noConversion_v3_TENA_Acceleration_v1_forceThisLibraryToBeLinked;
}  

#endif // ifndef TENA_Platform_DisturbanceServer_PublisherImpl_h
