/////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file TENA/Platform/DisturbanceServer/SubscriberImpl.h
 * \version 5.2.1
 *
 * \brief Contains all the \#include files for subscribing to
 * TENA::Platform SDOs.
 *
 * This header file aggregates numerous other header files needed by virtually
 * any TENA Middleware application that subscribes to
 * TENA::Platform SDOs using the implementation
 * defined in TENA/Platform/DisturbanceServer.
 *
 * It is the one header file that all TENA Middleware application programs
 * should \#include in order to subscribe to
 * TENA::Platform SDOs.
 */

#ifndef TENA_Platform_DisturbanceServer_SubscriberImpl_h
#define TENA_Platform_DisturbanceServer_SubscriberImpl_h

#include <TENA/Platform/Subscriber.h>
#include <DisturbanceServer_v1_TENA_Platform_v3_1_mscRegisterFactory.h>
#include "CallbackInfo.h"
#include "DestructionCallbackFactoryImpl.h"
#include "DestructionCallbackImpl.h"
#include "DiscoveryCallbackFactoryImpl.h"
#include "DiscoveryCallbackImpl.h"
#include "StateChangeCallbackFactoryImpl.h"
#include "StateChangeCallbackImpl.h"
#include "SubscriptionInfoImpl.h"

#endif // ifndef TENA_Platform_DisturbanceServer_SubscriberImpl_h
