#include <TENA/Middleware/Config.h>

//mg 04-26-07

#include <TENA/Platform/BasicImpl/PublisherImpl.h>

// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/UniqueID/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/Time/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/CoordinatedUniversalTime/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/Date/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GpsTime/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/UnixTime/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/PlatformType/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <DIS/EntityType/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/TSPI/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/AngularAcceleration/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/AngularVelocity/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeocentricAcceleration/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeocentricSpatialReferenceFrame/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/SpatialReferenceFrame/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeocentricOrientationEuler/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeocentricPosition/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeocentricVelocity/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeodeticAcceleration/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeodeticSpatialReferenceFrame/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeodeticOrientationEuler/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeodeticPosition/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/GeodeticVelocity/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalSphericalTangentPlaneAcceleration/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalSphericalTangentPlaneSpatialReferenceFrame/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalSphericalTangentPlaneOrientationEuler/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalSphericalTangentPlanePosition/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalSphericalTangentPlaneVelocity/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalTangentPlaneENUacceleration/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalTangentPlaneENUspatialReferenceFrame/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalTangentPlaneENUorientationEuler/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalTangentPlaneENUposition/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/LocalTangentPlaneENUvelocity/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/Acceleration/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/Orientation/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/Position/Includes.h>
// Include all the implementation files for contained types that are needed to
// access the state of this SDO
#include <TENA/Velocity/Includes.h>
// end mg

#include "configuration.h"

// These are the vars filled by TENA output and used to drive the 3D display
extern double _positionX;
extern double _positionY ;
extern double _positionZ ;
extern double _heading ;
extern double _theta ;
extern double _phi ;

extern double 	_elevation ;
extern double 	_velocity ;
extern double 	_xJitterOffset ;
extern double 	_yJitterOffset ;
extern double 	_zJitterOffset ;

extern int _UID;

bool joined = false;  //Boolean for signaling if joined TENA execution
bool DONE = false;    // flag to show app is exiting

void CalcVelocity(double xPos, double yPos, double zPos, double timeIncrement, 
				  double &xVel, double &yVel, double &zVel);

void TENA_Module(void)
{
	long updateCount = 0;  // counter
	short verbosity = 3;   // default TENA output verbosity val

	//int Consumer_ID = 100;
	//int Model_ID = EMERGENCYTRUCK;  //EmergencyTruck

	// TENA pointers
	TENA::Middleware::RuntimePtr pTENAmiddlewareRuntime_;
	TENA::Middleware::ExecutionPtr pExecution_;
	TENA::Middleware::SessionPtr pSession_;

	TENA::Platform::ServantPtr pPlatformServant_;
	TENA::Platform::ServantPtr p_Platform_Servant;
	TENA::LocalTangentPlaneENUspatialReferenceFrame::Pointer pLTPSRF_;

//	RTTC::EnvironmentalEffects::TerrainTypeChangeMessage::MessageSenderPtr pMessageSender;

	ConfigurationFile config_;  //configuration file values
	long millisecondsBetweenUpdates(100);

	try
	{
		config_.SetConfigurationFileName("config.txt"); // read configuration file
		config_.ReadFile();

		std::string sExecutionName = config_.GetExecutionName();  // retrieve config params
		std::string sSessionName = config_.GetSessionName();
		std::string sInitRef = config_.GetORBdefaultInitRef();

		int argc = 6;
		char * argv[] = {"-ORBdefaultInitRef", (char *) sInitRef.c_str(), "-executionName", (char *) sExecutionName.c_str(), "-sessionName", (char *) sSessionName.c_str(), NULL};

		TENA::Middleware::Configuration tenaMiddlewareConfiguration (
			argc,
			argv );

		pTENAmiddlewareRuntime_ = TENA::Middleware::RuntimePtr (
			TENA::Middleware::init( tenaMiddlewareConfiguration ) );

		pExecution_ = TENA::Middleware::ExecutionPtr (
			pTENAmiddlewareRuntime_->joinExecution( sExecutionName ) );

		pSession_ = TENA::Middleware::SessionPtr (
			pExecution_->createSession( sSessionName ) );

		// Create a PublicationInfoImpl helper object that can be used to provide
    // the RemoteMethodsImpl access to application variables/objects.  See the
    // TENA::Platform::DisturbanceServer::PublicationInfoImpl header file for
    // usage information.
    ///TENA::Platform::PublicationInfoPtr pPublicationInfo(
      ///new TENA::Platform::DisturbanceServer::PublicationInfoImpl );

	TENA::Platform::PublicationInfoPtr pPublicationInfo(
      new TENA::Platform::BasicImpl::PublicationInfoImpl );

    // Create a ServantFactory to create Platform objects.
    TENA::Platform::ServantFactoryPtr pServantFactory(
      pSession_->
        createServantFactory< TENA::Platform::ServantTraits >(
          pPublicationInfo ) );

	TENA::Middleware::CommunicationProperties communicationProperties;
    communicationProperties = TENA::Middleware::Reliable;

	// Create a Platform Servant that is returned as a smart pointer
   p_Platform_Servant = 
      pServantFactory->createServantUsingDefaultFactory(
        communicationProperties ) ;

   // from Stacy's PlatformSurrogate
   pLTPSRF_ = TENA::LocalTangentPlaneENUspatialReferenceFrame::Pointer( TENA::LocalTangentPlaneENUspatialReferenceFrame::Interface::create() );
		pLTPSRF_->set_orm(TENA::WGS84_ORM);
		pLTPSRF_->set_geodetic_latitude( config_.GetLocalTangentPlaneLatitude() );
		pLTPSRF_->set_geodetic_longitude( config_.GetLocalTangentPlaneLongitude() );
		pLTPSRF_->set_azimuth( config_.GetLocalTangentPlaneAzimuth() );  
		pLTPSRF_->set_x_false_origin( config_.GetLocalTangentPlaneXFalseOrigin() );
		pLTPSRF_->set_y_false_origin( config_.GetLocalTangentPlaneYFalseOrigin() );
		pLTPSRF_->set_height_offset( config_.GetLocalTangentPlaneHeightOffset() );

		pPlatformServant_ = TENA::Platform::ServantPtr (
			pServantFactory->createServantUsingDefaultFactory( ) );

		std::auto_ptr< TENA::Platform::PublicationStateUpdater >
			pPlatformUpdater(
				pPlatformServant_->createUpdater() );

		TENA::UniqueID::Pointer pPlatformID(pPlatformUpdater->get_platformID() );
		//pPlatformID->set_Values(Consumer_ID,Model_ID, Consumer_ID);
		pPlatformID->set_Values(_UID,_UID,_UID);
		pPlatformUpdater->set_platformID(pPlatformID);

		pPlatformUpdater->set_callSign("OSG Orbiting Platform");

		TENA::TSPI::Pointer pTSPI (pPlatformUpdater->get_tspi());
		if(pLTPSRF_.isValid())
		{
			pTSPI->set_LocalTangentPlaneENUposition(TENA::LocalTangentPlaneENUposition::Interface::create(), pLTPSRF_);
			pTSPI->set_LocalTangentPlaneENUorientationEuler(TENA::LocalTangentPlaneENUorientationEuler::Interface::create(), pLTPSRF_);
			pTSPI->set_LocalTangentPlaneENUvelocity(TENA::LocalTangentPlaneENUvelocity::Interface::create(), pLTPSRF_);
		}
		pPlatformUpdater->set_tspi(pTSPI);
	
		pPlatformServant_->commitUpdater(pPlatformUpdater );

		// Create a MessageSender to create TerrainTypeChangeMessage messages.
	//	 pMessageSender = 
	//	pSession_->
	//		createMessageSender< RTTC::EnvironmentalEffects::TerrainTypeChangeMessage::MessageTraits >(
	//			communicationProperties  );

		joined = true;
	}
	catch(...)
	{
		std::cout << "Unable to initialize TENA servant." << std::endl;
	}

	

	//bool bXPlaneInit = false;

	while(!DONE)  // actual publishing loop
	{
		// if user choses to enable XPlane interface, open up named pipe
	/*	if (bEnableXPlane && joined && !bXPlaneInit) {
			// spawn TENA publsher thread
			ACE_Thread_Manager *tm = ACE_Thread_Manager::instance();
			tm->spawn ((ACE_THR_FUNC) &StartXPlaneInterfaceThread, (void*)0);
			bXPlaneInit = true;
		}*/

		if(joined)
			pSession_->evokeMultipleCallbacks(50);
		else
			::Sleep(50);

	//	UpdateInputState(jsX, jsY);  // get joystick X & Y
		
	//	if(!ORBITING)
	//		ProcessPositionOrientation(20, jsX, jsY, 0.1);

		long const microsecondsBetweenUpdates(
        millisecondsBetweenUpdates * 1000 );

		// Set Time stamp (use milliseconds from Windows tickcount, but set in UnixTime
			// nanoseconds param
		DWORD StartTime = GetTickCount();
		std::cout << "TickCount - " << StartTime << std::endl;

        std::auto_ptr< TENA::Platform::PublicationStateUpdater >
			pPlatformUpdater( pPlatformServant_->createUpdater() );

	    TENA::TSPI::Pointer pTSPI (pPlatformUpdater->get_tspi());
		

		if(pLTPSRF_.isValid())
			{
				TENA::LocalTangentPlaneENUposition::Pointer pLocalTangentPlaneENUposition (pTSPI->get_LocalTangentPlaneENUposition(pLTPSRF_));
				pLocalTangentPlaneENUposition->set_x(_positionX + _xJitterOffset);
				pLocalTangentPlaneENUposition->set_y(_positionY + _yJitterOffset);
				pLocalTangentPlaneENUposition->set_z(_positionZ + _zJitterOffset);
				pTSPI->set_LocalTangentPlaneENUposition(pLocalTangentPlaneENUposition, pLTPSRF_);
        
				TENA::LocalTangentPlaneENUorientationEuler::Pointer pLocalTangentPlaneENUorientationEuler (pTSPI->get_LocalTangentPlaneENUorientationEuler(pLTPSRF_));
				pLocalTangentPlaneENUorientationEuler->set_psi(_heading);
				pLocalTangentPlaneENUorientationEuler->set_theta(_theta);
				pLocalTangentPlaneENUorientationEuler->set_phi(_phi);
				pTSPI->set_LocalTangentPlaneENUorientationEuler(pLocalTangentPlaneENUorientationEuler, pLTPSRF_);

				// XPlane Interface Globals
			/*	XPlane_x = _positionX + _xJitterOffset;
				XPlane_y = _positionY + _yJitterOffset;
				XPlane_z = _positionZ + _zJitterOffset;

				XPlane_psi = osg::RadiansToDegrees(_heading);
				global_heading = XPlane_z;
				XPlane_theta = 0.;
				XPlane_phi = 0.;

				XPlane_ID = Consumer_ID;
				XPlane_ModelID = Model_ID;*/

				double returnedXVel, returnedYVel, returnedZVel;

				CalcVelocity (_positionX, _positionY, _positionZ, StartTime,
					          returnedXVel, returnedYVel, returnedZVel);

				TENA::LocalTangentPlaneENUvelocity::Pointer pLocalTangentPlaneENUvelocity (pTSPI->get_LocalTangentPlaneENUvelocity(pLTPSRF_));
				pLocalTangentPlaneENUvelocity->set_vx(returnedXVel);
				pLocalTangentPlaneENUvelocity->set_vy(returnedYVel);
				pLocalTangentPlaneENUvelocity->set_vz(returnedZVel);
				pTSPI->set_LocalTangentPlaneENUvelocity(pLocalTangentPlaneENUvelocity, pLTPSRF_);
			}
			

			pPlatformUpdater->
				set_callSign("OSG Orbiting Platform");

			

			// Get a Pointer to the Local Class attribute "timeStamp"
			TENA::Time::Pointer
				pTime(
				pPlatformUpdater->
					get_timeStamp() );

		
			pTime->set_UnixTime(TENA::UnixTime::Interface::create());
			TENA::UnixTime::Pointer pUnixTime (pTime->get_UnixTime());
			pUnixTime->set_nanoseconds(StartTime);
			pTime->set_UnixTime(pUnixTime);


			// Change the value of the pPlatformUpdater's
			// local class attribute "timeStamp"
			pPlatformUpdater->
				set_timeStamp(
				pTime );

        // Pass the updater in to the servant to modify the state atomically
        pPlatformServant_->commitUpdater(
          pPlatformUpdater );

	   //updateCount++;

	}


}

// Function to calculate velocity based on UUT position and time step
// Mike Greene, Trideum Corp., 05-02-07
//
void CalcVelocity(double xPos, double yPos, double zPos, double timeIncrement, 
				  double &xVel, double &yVel, double &zVel)
{
	static double xPosLast = -99999.;   //these are used to save previous position
	static double yPosLast = -99999.;   //these are used to save previous position
	static double zPosLast = -99999.;   //these are used to save previous position
	static double timeIncrementLast = -99999.;

	if (xPosLast == -99999.) {   // first time through = need two points to calc velocity
		xVel = -999.;
		yVel = -999.;
		zVel = -999.;
		xPosLast = xPos;
		yPosLast = yPos;
		zPosLast = zPos;
		timeIncrementLast = timeIncrement;
	}
	else {

		xVel = 1000. * (xPos - xPosLast) / (timeIncrement - timeIncrementLast) ;  // convert to m/s
		yVel = 1000. * (yPos - yPosLast) / (timeIncrement - timeIncrementLast) ;  // convert to m/s
		zVel = 1000. * (zPos - zPosLast) / (timeIncrement - timeIncrementLast) ;  // convert to m/s

		// save current time step and positions for use in next calculation
		xPosLast = xPos;
		yPosLast = yPos;
		zPosLast = zPos;
		timeIncrementLast = timeIncrement;
	}

}
