//////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file basicImpl_TENA_Platform_v3_1_EXPORT.h
 * \version 5.2.1
 *
 * \brief Contains the definition of and documentation for
 * basicImpl_TENA_Platform_v3_1_EXPORT.
 *
 * This file contains the definition of and documentation for the
 * basicImpl_TENA_Platform_v3_1_EXPORT macro.
 */

#ifndef basicImpl_TENA_Platform_v3_1_EXPORT_h
#define basicImpl_TENA_Platform_v3_1_EXPORT_h

#include <DCT/System/config.h>

#if defined(_MSC_VER)
#  if defined (basicImpl_TENA_Platform_v3_1_COMPILING_DLL)
#    if defined (basicImpl_TENA_Platform_v3_1_COMPILING_EXE_OR_STATIC_LIB)
#      error "Both basicImpl_TENA_Platform_v3_1_COMPILING_DLL and basicImpl_TENA_Platform_v3_1_COMPILING_EXE_OR_STATIC_LIB may not be defined in the same compilation unit!"
#    else
#      define basicImpl_TENA_Platform_v3_1_EXPORT __declspec (dllexport)
#    endif
#  else
#    if defined (basicImpl_TENA_Platform_v3_1_COMPILING_EXE_OR_STATIC_LIB)
#      define basicImpl_TENA_Platform_v3_1_EXPORT
#    else
#      define basicImpl_TENA_Platform_v3_1_EXPORT __declspec (dllimport)
#    endif
#  endif
#else
/*!
 * \brief Define export macro to nothing, except on windows.
 *
 * On Windows, linkage must be set to dllimport, dllexport, or nothing depending
 * on how this code is being used.
 *
 * If you are compiling this code into a DLL, then define basicImpl_TENA_Platform_v3_1_COMPILING_DLL
 *
 * If you are just linking in a DLL build with this code, then you don't need to
 * define a special macro.  Linkage will automagically be set to dllimport.
 *
 * If you are compiling this code into an executable, static library, or if this
 * code was already compiled into a static library, and you are just linking it
 * in, then you need to define basicImpl_TENA_Platform_v3_1_COMPILING_EXE_OR_STATIC_LIB
 *
 * Defining both basicImpl_TENA_Platform_v3_1_COMPILING_DLL AND
 * basicImpl_TENA_Platform_v3_1_COMPILING_EXE_OR_STATIC_LIB
 * in the same compilation unit will result in an error.
 */
#  define basicImpl_TENA_Platform_v3_1_EXPORT
#endif

#endif // ifndef basicImpl_TENA_Platform_v3_1_EXPORT_h
