
#include <osgProducer/Viewer>
#include <osgProducer/ViewerEventHandler>
#include <Producer/CameraGroup>
#include <osg/Node>

#include <osg/Notify>
#include <osg/MatrixTransform>
#include <osgDB/Registry>
#include <osgDB/ReadFile>
#include <osgDB/FileUtils>

#include <osgGA/MatrixManipulator>
#include <osg/PositionAttitudeTransform>
#include <osg/Transform>

//-----------------------------------------------------------------------------
//Name:dot
//Desc:Determines the dot-product of two 3-D vectors
//-----------------------------------------------------------------------------
inline float dot(osg::Vec3f v1, osg::Vec3f v2) 
{
 return ( v1.x() * v2.x() + v1.y() * v2.y() + v1.z() * v2.z() );	
}         

//-----------------------------------------------------------------------------
//Name:cross
//Desc: Determines the cross-product of two 3-D vectors.
//-----------------------------------------------------------------------------
inline osg::Vec3f cross (osg::Vec3f v1, osg::Vec3f v2)
 {
 osg::Vec3f result;
 
 result.x() = (v1.y() * v2.z()) - (v2.y() * v1.z());
 result.y() = (v1.z() * v2.x()) - (v2.z() * v1.x());
 result.z() = (v1.x() * v2.y()) - (v2.x() * v1.y()); 	
 
 return (result);	
}         
//---------------------------------------------------------------------------
//Name:pointInPolygon
//Desc:
//---------------------------------------------------------------------------
bool pointInPolygon(osg::Vec3f point, osg::Vec3f vertices[], int numVertices)
{
    osg::Vec3d p = cross(vertices[numVertices-1] - point, vertices[0] - point);
    for (int i = 0; i < numVertices - 1; i++)
    {
        osg::Vec3f q = cross(vertices[i] - point, vertices[i+1] - point);
        if (dot(p, q) < 0)
           // Point not in polygon
            return false;
    }
    return true;
}

